Index: branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/NEMO/SAO_SRC/sao_write.F90
===================================================================
--- branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/NEMO/SAO_SRC/ooo_write.F90	(revision 4849)
+++ branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/NEMO/SAO_SRC/sao_write.F90	(revision 4850)
@@ -1,5 +1,5 @@
-MODULE ooo_write
+MODULE sao_write
    !!======================================================================
-   !!                       ***  MODULE ooo_write  ***
+   !!                       ***  MODULE sao_write  ***
    !!======================================================================
 
@@ -13,7 +13,7 @@
    PRIVATE
 
-   PUBLIC ooo_wri_init
-   PUBLIC ooo_wri_default
-   PUBLIC ooo_wri_extra
+   PUBLIC sao_wri_init
+   PUBLIC sao_wri_default
+   PUBLIC sao_wri_extra
 
    ! Type kinds for class 4 data.
@@ -25,14 +25,14 @@
    REAL(clsp), PARAMETER :: clrmdi =  99999   !: Reals
 
-   INTERFACE ooo_wri_extra
-      MODULE PROCEDURE ooo_wri_extra_3d_index, ooo_wri_extra_4d, ooo_wri_extra_4d_index
+   INTERFACE sao_wri_extra
+      MODULE PROCEDURE sao_wri_extra_3d_index, sao_wri_extra_4d, sao_wri_extra_4d_index
    END INTERFACE
 
    CONTAINS
 
-      SUBROUTINE ooo_wri_extra_3d_index(cdfilename, cdvarname, ndeps, nvars, &
+      SUBROUTINE sao_wri_extra_3d_index(cdfilename, cdvarname, ndeps, nvars, &
                                &  nobs, kstart, kcount, pdata)
          !!----------------------------------------------------------------------
-         !!                    ***  ROUTINE ooo_wri_extra_3d  ***
+         !!                    ***  ROUTINE sao_wri_extra_3d  ***
          !!
          !! ** Purpose : Write 3d variables to class 4 file.
@@ -55,5 +55,5 @@
                  & dimid, &      !:
                  & varid         !:
-         CHARACTER(len=16), PARAMETER :: cpname = 'ooo_wri_extra_3d'
+         CHARACTER(len=16), PARAMETER :: cpname = 'sao_wri_extra_3d'
          ! Open netcdf file
          CALL chkerr(nf90_open(trim(cdfilename), nf90_write, ncid), cpname, __LINE__ )
@@ -63,10 +63,10 @@
          ! Close netcdf file
          CALL chkerr(nf90_close(ncid), cpname, __LINE__ )
-      END SUBROUTINE ooo_wri_extra_3d_index
-
-      SUBROUTINE ooo_wri_extra_4d_index(cdfilename, cdvarname, ndeps, nfcst, &
+      END SUBROUTINE sao_wri_extra_3d_index
+
+      SUBROUTINE sao_wri_extra_4d_index(cdfilename, cdvarname, ndeps, nfcst, &
                                &  nvars, nobs, kstart, kcount, pdata)
          !!----------------------------------------------------------------------
-         !!                    ***  ROUTINE ooo_wri_extra_4d  ***
+         !!                    ***  ROUTINE sao_wri_extra_4d  ***
          !!
          !! ** Purpose : Write 4d variables to class 4 file.
@@ -90,5 +90,5 @@
                  & dimid, &      !:
                  & varid         !:
-         CHARACTER(len=22), PARAMETER :: cpname = 'ooo_wri_extra_4d_index'
+         CHARACTER(len=22), PARAMETER :: cpname = 'sao_wri_extra_4d_index'
          ! Open netcdf file
          CALL chkerr(nf90_open(trim(cdfilename), nf90_write, ncid), cpname, __LINE__ )
@@ -98,10 +98,10 @@
          ! Close netcdf file
          CALL chkerr(nf90_close(ncid), cpname, __LINE__ )
-      END SUBROUTINE ooo_wri_extra_4d_index
-
-      SUBROUTINE ooo_wri_extra_4d(cdfilename, cdvarname, ndeps, nfcst, &
+      END SUBROUTINE sao_wri_extra_4d_index
+
+      SUBROUTINE sao_wri_extra_4d(cdfilename, cdvarname, ndeps, nfcst, &
                                &  nvars, nobs, pdata)
          !!----------------------------------------------------------------------
-         !!                    ***  ROUTINE ooo_wri_extra_4d  ***
+         !!                    ***  ROUTINE sao_wri_extra_4d  ***
          !!
          !! ** Purpose : Write 4d variables to class 4 file.
@@ -122,5 +122,5 @@
                  & dimid, &      !:
                  & varid         !:
-         CHARACTER(len=16), PARAMETER :: cpname = 'ooo_wri_extra_4d'
+         CHARACTER(len=16), PARAMETER :: cpname = 'sao_wri_extra_4d'
          ! Open netcdf file
          CALL chkerr(nf90_open(trim(cdfilename), nf90_write, ncid), cpname, __LINE__ )
@@ -130,12 +130,12 @@
          ! Close netcdf file
          CALL chkerr(nf90_close(ncid), cpname, __LINE__ )
-      END SUBROUTINE ooo_wri_extra_4d
-
-      SUBROUTINE ooo_wri_default(cdfilename, nobs, nvars, nfcst, ndeps, & 
+      END SUBROUTINE sao_wri_extra_4d
+
+      SUBROUTINE sao_wri_default(cdfilename, nobs, nvars, nfcst, ndeps, & 
                              &   cdtyp, cdwmo, cunit, cvnam, &
                              &   plam, pphi, pdep, ptim, pob, plead, &
                              &   kqc, pmjuld)
          !!----------------------------------------------------------------------
-         !!                    ***  ROUTINE ooo_wri_default  ***
+         !!                    ***  ROUTINE sao_wri_default  ***
          !!
          !! ** Purpose : Write standard variables to class 4 file.
@@ -192,5 +192,5 @@
                  & dimid, & !:
                  & varid    !:
-         CHARACTER(len=15), PARAMETER :: cpname = 'ooo_wri_default'
+         CHARACTER(len=15), PARAMETER :: cpname = 'sao_wri_default'
          ! Open netcdf file
          CALL chkerr(nf90_open(trim(cdfilename), nf90_write, ncid), cpname, __LINE__ )
@@ -242,11 +242,11 @@
          ! Close netcdf file
          CALL chkerr(nf90_close(ncid), cpname, __LINE__ )
-      END SUBROUTINE ooo_wri_default
-
-      SUBROUTINE ooo_wri_init(cconf, csys, ckind, cversion, ccont, &
+      END SUBROUTINE sao_wri_default
+
+      SUBROUTINE sao_wri_init(cconf, csys, ckind, cversion, ccont, &
                             & cinst, cdate, nproc, nobs, nvars, &
                             & ndeps, nfcst, cdfilename)
          !!----------------------------------------------------------------------
-         !!                    ***  ROUTINE ooo_wri_init  ***
+         !!                    ***  ROUTINE sao_wri_init  ***
          !!
          !! ** Purpose : Initialise a class 4 file.
@@ -302,5 +302,5 @@
          INTEGER, DIMENSION(4) :: &
                  & dim4a         !: 4 dimensional settings
-         CHARACTER(len=12), PARAMETER :: cpname = 'ooo_wri_init'
+         CHARACTER(len=12), PARAMETER :: cpname = 'sao_wri_init'
          ! Global att variables
          CHARACTER(len=40) :: date_str
@@ -586,6 +586,6 @@
             CALL chkerr(nf90_close(ncid), cpname, __LINE__ )
          END IF
-      END SUBROUTINE ooo_wri_init
-
-
-END MODULE ooo_write
+      END SUBROUTINE sao_wri_init
+
+
+END MODULE sao_write